#============================================================================================================
#
#	ǗCGIx[XW[
#
#============================================================================================================
package	SAURON;

use strict;
use warnings;

require './module/thorin.pl';

#------------------------------------------------------------------------------------------------------------
#
#	RXgN^
#	-------------------------------------------------------------------------------------
#	@param	Ȃ
#	@return	W[IuWFNg
#
#------------------------------------------------------------------------------------------------------------
sub new
{
	my $class = shift;
	
	my $obj = {
		'SYS'		=> undef,		# MELKORێ
		'FORM'		=> undef,		# SAMWISEێ
		'INN'		=> undef,		# THORINێ
		'MENU'		=> undef,		# @\Xg
	};
	bless $obj, $class;
	
	return $obj;
}

#------------------------------------------------------------------------------------------------------------
#
#	IuWFNg
#	-------------------------------------------------------------------------------------
#	@param	$Sys		MELKOR
#	@param	$Form		SAMWISE
#	@return	THORINW[
#
#------------------------------------------------------------------------------------------------------------
sub Create
{
	my $this = shift;
	my ($Sys, $Form) = @_;
	
	$this->{'SYS'}		= $Sys;
	$this->{'FORM'}		= $Form;
	$this->{'INN'}		= THORIN->new;
	$this->{'MENU'}		= [];
	
	return $this->{'INN'};
}

#------------------------------------------------------------------------------------------------------------
#
#	j[̐ݒ
#	-------------------------------------------------------------------------------------
#	@param	$str	\
#	@param	$url	WvURL
#	@return	Ȃ
#
#------------------------------------------------------------------------------------------------------------
sub SetMenu
{
	my $this = shift;
	my ($str, $url) = @_;
	
	push @{$this->{'MENU'}}, {
		'str'	=> $str,
		'url'	=> $url,
	};
}

#------------------------------------------------------------------------------------------------------------
#
#	y[Wo
#	-------------------------------------------------------------------------------------
#	@param	$title	y[W^Cg
#	@param	$mode	
#	@param	$indata	
#	@return	Ȃ
#
#------------------------------------------------------------------------------------------------------------
sub Print
{
	my $this = shift;
	my ($title, $mode, $indata) = @_;
	
	my $Sys = $this->{'SYS'};
	my $Form = $this->{'FORM'};
	my $CGI = $Sys->Get('ADMIN');
	
	my $Page = THORIN->new;
	$Page->Init('admin.tt');
	$Page->Set({
		'title'		=> $title,
		'datapath'	=> $Sys->Get('DATA'),
		'version'	=> $Sys->Get('VERSION'),
	});
	
	if ($mode) {
		$Page->Set({
			'mode'		=> $mode,
			'menu'		=> $this->{'MENU'},
			'username'	=> $Form->Get('UserName'),
			'sid'		=> $Form->Get('SessionID'),
			'isupdate'	=> $CGI->{'NEWRELEASE'}->Get('Update'),
		});
	}
	
	if (defined $indata) {
		$Page->Set($indata);
	} else {
		warn;
		$this->{'INN'}->Flush(0, 0, \my $inner);
		$Page->Set({'innerhtml' => $inner});
	}
	
	$Page->OutputContentType('text/html');
	$Page->Output;
	
	my ($user, $system, $cuser, $csystem) = times;
	print STDERR "user:$user system:$system cuser:$cuser csystem:$csystem\n";
	
	#foreach my $key (sort keys %INC) {
	#	print STDERR "$key\n" if ($key =~ m/Template/);
	#}
}

#------------------------------------------------------------------------------------------------------------
#
#	ʂ̏o
#	-------------------------------------------------------------------------------------
#	@param	$name	
#	@param	$LogArr	O
#	@return	Ȃ
#
#------------------------------------------------------------------------------------------------------------
sub PreparePageComplete
{
	my $this = shift;
	my ($name, $LogArr) = @_;
	
	my $indata = {
		'title'		=> 'Process Complete',
		'intmpl'	=> 'complete',
		'pname'		=> $name,
		'log'		=> $LogArr,
	};
	
	return $indata;
}

sub PrintComplete
{
	my $this = shift;
	my ($name, $LogArr) = @_;
	
	my $PageIn = $this->{'INN'};
	
	$PageIn->Print(<<HTML);
  <table border="0" cellspacing="0" cellpadding="0" width="100%" align="center">
   <tr>
    <td>
    
    <div class="oExcuted">
     $name𐳏Ɋ܂B
    </div>
   
    <div class="LogExport">O</div>
    <hr>
    <blockquote class="LogExport">
HTML
	
	# O̕\
	foreach my $text (@$LogArr) {
		$PageIn->Print("     $text<br>\n");
	}
	
	$PageIn->Print(<<HTML);
    </blockquote>
    <hr>
    </td>
   </tr>
  </table>
HTML
	
}

#------------------------------------------------------------------------------------------------------------
#
#	G[̕\
#	-------------------------------------------------------------------------------------
#	@param	$LogArr	Op
#	@return	Ȃ
#
#------------------------------------------------------------------------------------------------------------
sub PreparePageError
{
	my $this = shift;
	my ($LogArr) = @_;
	
	my %err2mes = (
		0		=> 'sȃG[܂B',
		1000	=> '{@\̏s錠܂B',
		1001	=> '͕K{ڂ󗓂ɂȂĂ܂B',
		1002	=> 'ݒ荀ڂɋKO̕gpĂ܂B',
		2000	=> 'ffBNg̍쐬Ɏs܂B'
				 . 'p[~bVA܂͊ɓ̌f쐬ĂȂmFĂB',
		2001	=> 'SETTING.TXT̐Ɏs܂B',
		2002	=> 'f\vf̐Ɏs܂B',
		2003	=> 'ߋO̐Ɏs܂B',
		2004	=> 'f̍XVɎs܂B',
	);
	
	my $errnum = pop(@$LogArr);
	my $errmes = $err2mes{$errnum};
	$errmes = $err2mes{0} if (!defined $errmes);
	
	my $indata = {
		'title'		=> 'Process Failed',
		'intmpl'	=> 'error',
		'errnum'	=> $errnum,
		'errmes'	=> $errmes,
		'log'		=> $LogArr,
	};
	
	return $indata;
}

sub PrintError
{
	my $this = shift;
	my ($LogArr) = @_;
	
	my $PageIn = $this->{'INN'};
	
	# G[R[h̒o
	my $ecode = pop @$LogArr;
	
	$PageIn->Print(<<HTML);
  <table border="0" cellspacing="0" cellpadding="0" width="100%" align="center">
   <tr>
    <td>
    
    <div class="xExcuted">
HTML
	
	if ($ecode == 1000) {
		$PageIn->Print("     ERROR:$ecode - {@\\̏s錠܂B\n");
	}
	elsif ($ecode == 1001) {
		$PageIn->Print("     ERROR:$ecode - ͕K{ڂ󗓂ɂȂĂ܂B\n");
	}
	elsif ($ecode == 1002) {
		$PageIn->Print("     ERROR:$ecode - ݒ荀ڂɋKO̕gpĂ܂B\n");
	}
	elsif ($ecode == 2000) {
		$PageIn->Print("     ERROR:$ecode - ffBNg̍쐬Ɏs܂B<br>\n");
		$PageIn->Print("     p[~bVA܂͊ɓ̌f쐬ĂȂmFĂB\n");
	}
	elsif ($ecode == 2001) {
		$PageIn->Print("     ERROR:$ecode - SETTING.TXT̐Ɏs܂B\n");
	}
	elsif ($ecode == 2002) {
		$PageIn->Print("     ERROR:$ecode - f\\vf̐Ɏs܂B\n");
	}
	elsif ($ecode == 2003) {
		$PageIn->Print("     ERROR:$ecode - ߋO̐Ɏs܂B\n");
	}
	elsif ($ecode == 2004) {
		$PageIn->Print("     ERROR:$ecode - f̍XVɎs܂B\n");
	}
	else {
		$PageIn->Print("     ERROR:$ecode - sȃG[܂B\n");
	}
	
	$PageIn->Print(<<HTML);
    </div>
    
HTML

	# G[OΏo͂
	if (scalar(@$LogArr)) {
		$PageIn->Print('<hr>');
		$PageIn->Print("    <blockquote>");
		foreach my $text (@$LogArr) {
			$PageIn->Print("    $text<br>\n");
		}
		$PageIn->Print("    </blockquote>");
		$PageIn->Print('<hr>');
	}
	
	$PageIn->Print(<<HTML);
    </td>
   </tr>
  </table>
HTML
	
}

#============================================================================================================
#	W[I[
#============================================================================================================
1;
